comment ~

Extended TEA

wielkosc bloku : 8 bajtow
dlugosc klucza : 16 bajtow

	invoke	ExTEA_encode, ADDR _data, ADDR _key
	invoke	ExTEA_decode, ADDR _data, ADDR _key

WiteG//xtreeme

~

ExTEA_encode	PROTO	:DWORD,:DWORD
ExTEA_decode	PROTO	:DWORD,:DWORD

.data?
internal_key	dd 4 dup(?)

.code
ExTEA_encode	PROC	ptrData:DWORD, ptrKey:DWORD
	pushad

	mov	esi, ptrKey	
	mov	eax, dword ptr [esi]
	mov	ebx, dword ptr [esi+4]
	mov	ecx, dword ptr [esi+8]
	mov	edx, dword ptr [esi+12]	
	mov	dword ptr [internal_key], eax
	mov	dword ptr [internal_key+4], ebx
	mov	dword ptr [internal_key+8], ecx
	mov	dword ptr [internal_key+12], edx

	push	ebp
	mov	ebx, ptrData
	xor	edx, edx				;suma
	mov	esi, dword ptr [ebx]
	mov	edi, dword ptr [ebx+4]
	mov	ebp, 32

_loop:
	mov	eax, edi
	mov	ebx, edi

	shl	eax, 4					;z << 4
	shr	ebx, 5					;z >> 5
	mov	ecx, edx
	xor	eax, ebx				;(z << 4 ^ z >> 5)
	and	ecx, 3					;sum&3
	add	eax, edi				;[(z << 4 ^ z >> 5) + z]
	mov	ebx, dword ptr [internal_key+4*ecx]
	add	ebx, edx
	xor	eax, ebx				;[(z << 4 ^ z >> 5) + z] ^ [sum + k[sum&3]]
	
	add	edx, 9E3779B9h				;sum += DELTA
	add	esi, eax				;y += [(z << 4 ^ z >> 5) + z] ^ [sum + k[sum&3]]

	mov	ecx, edx
	mov	eax, esi
	mov	ebx, esi
	shl	eax, 4					;z << 4
	shr	ebx, 5					;z >> 5
	shr	ecx, 11
	xor	eax, ebx				;(y << 4 ^ y >> 5)
	and	ecx, 3					;[sum>>11 & 3]
	mov	ebx, edx
	add	eax, esi				;[(y << 4 ^ y >> 5) + y]
	add	ebx, dword ptr [internal_key+4*ecx]	;k[sum>>11 & 3]
	xor	eax, ebx				;[(y << 4 ^ y >> 5) + y] ^ [sum + k[sum>>11 & 3]]

	add	edi, eax				;z += [(y << 4 ^ y >> 5) + y] ^ [sum + k[sum>>11 & 3]]
	dec	ebp
	jnz	_loop

	mov	dword ptr [internal_key], ebp
	mov	dword ptr [internal_key+4], ebp
	mov	dword ptr [internal_key+8], ebp
	mov	dword ptr [internal_key+12], ebp
	
	pop	ebp
	mov	ebx, ptrData
	mov	dword ptr [ebx], esi
	mov	dword ptr [ebx+4], edi
	popad
	ret
ExTEA_encode	ENDP

ExTEA_decode	PROC	ptrData:DWORD, ptrKey:DWORD
	pushad
	
	mov	esi, ptrKey	
	mov	eax, dword ptr [esi]
	mov	ebx, dword ptr [esi+4]
	mov	ecx, dword ptr [esi+8]
	mov	edx, dword ptr [esi+12]	
	mov	dword ptr [internal_key], eax
	mov	dword ptr [internal_key+4], ebx
	mov	dword ptr [internal_key+8], ecx
	mov	dword ptr [internal_key+12], edx

	push	ebp
	mov	ebx, ptrData
	mov	edx, 0C6EF3720h
	mov	esi, dword ptr [ebx]
	mov	edi, dword ptr [ebx+4]
	mov	ebp, 32

_loop:
	mov	eax, esi
	mov	ebx, esi

	shl	eax, 4					;y << 4
	shr	ebx, 5					;y >> 5
	mov	ecx, edx
	xor	eax, ebx				;(y << 4 ^ y >> 5)
	shr	ecx, 11					;sum>>11
	add	eax, esi				;(y << 4 ^ y >> 5) + y
	mov	ebx, edx
	and	ecx, 3					;[sum>>11 & 3]

	sub	edx, 9E3779B9h				;sum -= DELTA

	add	ebx, dword ptr [internal_key+4*ecx]	;[sum + k[sum>>11 & 3]]
	xor	ebx, eax

	sub	edi, ebx				;z -= (y << 4 ^ y >> 5) + y ^ sum + k[sum>>11 & 3]

	mov	eax, edi
	mov	ebx, edi

	shl	eax, 4					;z << 4
	shr	ebx, 5					;z >> 5
	mov	ecx, edx
	xor	eax, ebx				;(z << 4 ^ z >> 5)
	and	ecx, 3					;[sum & 3]
	mov	ebx, edx
	add	eax, edi				;(z << 4 ^ z >> 5) + z
	add	ebx, dword ptr [internal_key+4*ecx]	;[sum + k[sum & 3]]
	xor	ebx, eax				;[(z << 4 ^ z >> 5) + z] ^ [sum + k[sum&3]];

	sub	esi, ebx				;y -= [(z << 4 ^ z >> 5) + z] ^ [sum + k[sum&3]];

	dec	ebp
	jnz	_loop

	mov	dword ptr [internal_key], ebp
	mov	dword ptr [internal_key+4], ebp
	mov	dword ptr [internal_key+8], ebp
	mov	dword ptr [internal_key+12], ebp
	
	pop	ebp
	mov	ebx, ptrData
	mov	dword ptr [ebx], esi
	mov	dword ptr [ebx+4], edi
	popad
	ret
ExTEA_decode	ENDP